---
title: TypedArray.prototype.copyWithin()
slug: Web/JavaScript/Reference/Global_Objects/TypedArray/copyWithin
tags:
  - JavaScript
  - Method
  - Prototype
  - TypedArray
  - TypedArrays
---
<div>{{JSRef}}</div>

<p>The <code><strong>copyWithin()</strong></code> method copies the sequence of array elements within the array to the position starting at <code><var>target</var></code>. The copy is taken from the index positions of the second and third arguments <code><var>start</var></code> and <code><var>end</var></code>. The <code><var>end</var></code> argument is optional and defaults to the length of the array. This method has the same algorithm as {{jsxref("Array.prototype.copyWithin")}}. <em>TypedArray</em> is one of the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/TypedArray#TypedArray_objects">typed array types</a> here.</p>

<div>{{EmbedInteractiveExample("pages/js/typedarray-copywithin.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><code><var>typedarray</var>.copyWithin(<var>target</var>, <var>start</var>[, <var>end</var> = this.length])</code></pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>target</var></code></dt>
 <dd>Target start index position where to copy the elements to.</dd>
 <dt><code><var>start</var></code></dt>
 <dd>Source start index position where to start copying elements from.</dd>
 <dt><code><var>end</var></code> {{optional_inline}}</dt>
 <dd>Optional. Source end index position where to end copying elements from.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The modified array.</p>

<h2 id="Description">Description</h2>

<p>See {{jsxref("Array.prototype.copyWithin")}} for more details.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_copyWithin">Using copyWithin</h3>

<pre class="brush: js">var buffer = new ArrayBuffer(8);
var uint8 = new Uint8Array(buffer);
uint8.set([1,2,3]);
console.log(uint8); // Uint8Array [ 1, 2, 3, 0, 0, 0, 0, 0 ]
uint8.copyWithin(3,0,3);
console.log(uint8); // Uint8Array [ 1, 2, 3, 1, 2, 3, 0, 0 ]
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-%typedarray%.prototype.copywithin', 'TypedArray.prototype.copyWithin')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.TypedArray.copyWithin")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("TypedArray")}}</li>
</ul>
